/**
 * Pyx4me framework
 * Copyright (C) 2006-2008 pyx4j.com.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 * 
 * @author vlads
 * @version $Id: ObexDeploy1Mojo.java 2873 2008-12-27 00:57:36Z vlads $
 */
package com.pyx4me.maven.obex;

import org.apache.maven.plugin.MojoExecutionException;
import org.apache.maven.plugin.MojoFailureException;

/**
 * Handy shortcut for "obex -Dobex.c=1" if you have multiple phones Use
 * configuration 1 for application installation.
 * 
 * @author vlads
 * 
 * @goal d1
 * @description Handy shortcut for obex:deploy if you have multiple phones, Use
 *              configuration 1
 */
public class ObexDeploy1Mojo extends ObexDeployMojo {

	/**
	 * Specifies optional suffix for server ID to use.
	 * 
	 * @parameter expression="${obex.c}" default-value="1"
	 */
	protected String serverSufix = "1";

	public void execute() throws MojoExecutionException, MojoFailureException {
		super.serverSufix = this.serverSufix;
		super.execute();
	}

}
